// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: subscriptions.proto

#ifndef PROTOBUF_subscriptions_2eproto__INCLUDED
#define PROTOBUF_subscriptions_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/unknown_field_set.h>
#include "enums.pb.h"
// @@protoc_insertion_point(includes)

namespace protobuf_subscriptions_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[6];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
void AddDescriptors();
void InitDefaultsSubscribeMessageImpl();
void InitDefaultsSubscribeMessage();
void InitDefaultsSubscribeReply_ErrorImpl();
void InitDefaultsSubscribeReply_Error();
void InitDefaultsSubscribeReplyImpl();
void InitDefaultsSubscribeReply();
void InitDefaultsUnsubscribeMessageImpl();
void InitDefaultsUnsubscribeMessage();
void InitDefaultsUnsubscribeReply_ErrorImpl();
void InitDefaultsUnsubscribeReply_Error();
void InitDefaultsUnsubscribeReplyImpl();
void InitDefaultsUnsubscribeReply();
inline void InitDefaults() {
  InitDefaultsSubscribeMessage();
  InitDefaultsSubscribeReply_Error();
  InitDefaultsSubscribeReply();
  InitDefaultsUnsubscribeMessage();
  InitDefaultsUnsubscribeReply_Error();
  InitDefaultsUnsubscribeReply();
}
}  // namespace protobuf_subscriptions_2eproto
namespace mascot {
class SubscribeMessage;
class SubscribeMessageDefaultTypeInternal;
extern SubscribeMessageDefaultTypeInternal _SubscribeMessage_default_instance_;
class SubscribeReply;
class SubscribeReplyDefaultTypeInternal;
extern SubscribeReplyDefaultTypeInternal _SubscribeReply_default_instance_;
class SubscribeReply_Error;
class SubscribeReply_ErrorDefaultTypeInternal;
extern SubscribeReply_ErrorDefaultTypeInternal _SubscribeReply_Error_default_instance_;
class UnsubscribeMessage;
class UnsubscribeMessageDefaultTypeInternal;
extern UnsubscribeMessageDefaultTypeInternal _UnsubscribeMessage_default_instance_;
class UnsubscribeReply;
class UnsubscribeReplyDefaultTypeInternal;
extern UnsubscribeReplyDefaultTypeInternal _UnsubscribeReply_default_instance_;
class UnsubscribeReply_Error;
class UnsubscribeReply_ErrorDefaultTypeInternal;
extern UnsubscribeReply_ErrorDefaultTypeInternal _UnsubscribeReply_Error_default_instance_;
}  // namespace mascot
namespace mascot {

// ===================================================================

class SubscribeMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.SubscribeMessage) */ {
 public:
  SubscribeMessage();
  virtual ~SubscribeMessage();

  SubscribeMessage(const SubscribeMessage& from);

  inline SubscribeMessage& operator=(const SubscribeMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  SubscribeMessage(SubscribeMessage&& from) noexcept
    : SubscribeMessage() {
    *this = ::std::move(from);
  }

  inline SubscribeMessage& operator=(SubscribeMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const SubscribeMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const SubscribeMessage* internal_default_instance() {
    return reinterpret_cast<const SubscribeMessage*>(
               &_SubscribeMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    0;

  void Swap(SubscribeMessage* other);
  friend void swap(SubscribeMessage& a, SubscribeMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline SubscribeMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  SubscribeMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const SubscribeMessage& from);
  void MergeFrom(const SubscribeMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(SubscribeMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // string attributeName = 2;
  void clear_attributename();
  static const int kAttributeNameFieldNumber = 2;
  const ::std::string& attributename() const;
  void set_attributename(const ::std::string& value);
  #if LANG_CXX11
  void set_attributename(::std::string&& value);
  #endif
  void set_attributename(const char* value);
  void set_attributename(const char* value, size_t size);
  ::std::string* mutable_attributename();
  ::std::string* release_attributename();
  void set_allocated_attributename(::std::string* attributename);

  // .mascot.SubscriptionFlavor flavor = 3;
  void clear_flavor();
  static const int kFlavorFieldNumber = 3;
  ::mascot::SubscriptionFlavor flavor() const;
  void set_flavor(::mascot::SubscriptionFlavor value);

  // @@protoc_insertion_point(class_scope:mascot.SubscribeMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  ::google::protobuf::internal::ArenaStringPtr attributename_;
  int flavor_;
  mutable int _cached_size_;
  friend struct ::protobuf_subscriptions_2eproto::TableStruct;
  friend void ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeMessageImpl();
};
// -------------------------------------------------------------------

class SubscribeReply_Error : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.SubscribeReply.Error) */ {
 public:
  SubscribeReply_Error();
  virtual ~SubscribeReply_Error();

  SubscribeReply_Error(const SubscribeReply_Error& from);

  inline SubscribeReply_Error& operator=(const SubscribeReply_Error& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  SubscribeReply_Error(SubscribeReply_Error&& from) noexcept
    : SubscribeReply_Error() {
    *this = ::std::move(from);
  }

  inline SubscribeReply_Error& operator=(SubscribeReply_Error&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const SubscribeReply_Error& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const SubscribeReply_Error* internal_default_instance() {
    return reinterpret_cast<const SubscribeReply_Error*>(
               &_SubscribeReply_Error_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    1;

  void Swap(SubscribeReply_Error* other);
  friend void swap(SubscribeReply_Error& a, SubscribeReply_Error& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline SubscribeReply_Error* New() const PROTOBUF_FINAL { return New(NULL); }

  SubscribeReply_Error* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const SubscribeReply_Error& from);
  void MergeFrom(const SubscribeReply_Error& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(SubscribeReply_Error* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string message = 2;
  void clear_message();
  static const int kMessageFieldNumber = 2;
  const ::std::string& message() const;
  void set_message(const ::std::string& value);
  #if LANG_CXX11
  void set_message(::std::string&& value);
  #endif
  void set_message(const char* value);
  void set_message(const char* value, size_t size);
  ::std::string* mutable_message();
  ::std::string* release_message();
  void set_allocated_message(::std::string* message);

  // int64 code = 1;
  void clear_code();
  static const int kCodeFieldNumber = 1;
  ::google::protobuf::int64 code() const;
  void set_code(::google::protobuf::int64 value);

  // @@protoc_insertion_point(class_scope:mascot.SubscribeReply.Error)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr message_;
  ::google::protobuf::int64 code_;
  mutable int _cached_size_;
  friend struct ::protobuf_subscriptions_2eproto::TableStruct;
  friend void ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeReply_ErrorImpl();
};
// -------------------------------------------------------------------

class SubscribeReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.SubscribeReply) */ {
 public:
  SubscribeReply();
  virtual ~SubscribeReply();

  SubscribeReply(const SubscribeReply& from);

  inline SubscribeReply& operator=(const SubscribeReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  SubscribeReply(SubscribeReply&& from) noexcept
    : SubscribeReply() {
    *this = ::std::move(from);
  }

  inline SubscribeReply& operator=(SubscribeReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const SubscribeReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const SubscribeReply* internal_default_instance() {
    return reinterpret_cast<const SubscribeReply*>(
               &_SubscribeReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    2;

  void Swap(SubscribeReply* other);
  friend void swap(SubscribeReply& a, SubscribeReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline SubscribeReply* New() const PROTOBUF_FINAL { return New(NULL); }

  SubscribeReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const SubscribeReply& from);
  void MergeFrom(const SubscribeReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(SubscribeReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  typedef SubscribeReply_Error Error;

  // accessors -------------------------------------------------------

  // .mascot.SubscribeReply.Error error = 2;
  bool has_error() const;
  void clear_error();
  static const int kErrorFieldNumber = 2;
  const ::mascot::SubscribeReply_Error& error() const;
  ::mascot::SubscribeReply_Error* release_error();
  ::mascot::SubscribeReply_Error* mutable_error();
  void set_allocated_error(::mascot::SubscribeReply_Error* error);

  // bool success = 1;
  void clear_success();
  static const int kSuccessFieldNumber = 1;
  bool success() const;
  void set_success(bool value);

  // @@protoc_insertion_point(class_scope:mascot.SubscribeReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::mascot::SubscribeReply_Error* error_;
  bool success_;
  mutable int _cached_size_;
  friend struct ::protobuf_subscriptions_2eproto::TableStruct;
  friend void ::protobuf_subscriptions_2eproto::InitDefaultsSubscribeReplyImpl();
};
// -------------------------------------------------------------------

class UnsubscribeMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.UnsubscribeMessage) */ {
 public:
  UnsubscribeMessage();
  virtual ~UnsubscribeMessage();

  UnsubscribeMessage(const UnsubscribeMessage& from);

  inline UnsubscribeMessage& operator=(const UnsubscribeMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  UnsubscribeMessage(UnsubscribeMessage&& from) noexcept
    : UnsubscribeMessage() {
    *this = ::std::move(from);
  }

  inline UnsubscribeMessage& operator=(UnsubscribeMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const UnsubscribeMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const UnsubscribeMessage* internal_default_instance() {
    return reinterpret_cast<const UnsubscribeMessage*>(
               &_UnsubscribeMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    3;

  void Swap(UnsubscribeMessage* other);
  friend void swap(UnsubscribeMessage& a, UnsubscribeMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline UnsubscribeMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  UnsubscribeMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const UnsubscribeMessage& from);
  void MergeFrom(const UnsubscribeMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(UnsubscribeMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // string attributeName = 2;
  void clear_attributename();
  static const int kAttributeNameFieldNumber = 2;
  const ::std::string& attributename() const;
  void set_attributename(const ::std::string& value);
  #if LANG_CXX11
  void set_attributename(::std::string&& value);
  #endif
  void set_attributename(const char* value);
  void set_attributename(const char* value, size_t size);
  ::std::string* mutable_attributename();
  ::std::string* release_attributename();
  void set_allocated_attributename(::std::string* attributename);

  // @@protoc_insertion_point(class_scope:mascot.UnsubscribeMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  ::google::protobuf::internal::ArenaStringPtr attributename_;
  mutable int _cached_size_;
  friend struct ::protobuf_subscriptions_2eproto::TableStruct;
  friend void ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeMessageImpl();
};
// -------------------------------------------------------------------

class UnsubscribeReply_Error : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.UnsubscribeReply.Error) */ {
 public:
  UnsubscribeReply_Error();
  virtual ~UnsubscribeReply_Error();

  UnsubscribeReply_Error(const UnsubscribeReply_Error& from);

  inline UnsubscribeReply_Error& operator=(const UnsubscribeReply_Error& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  UnsubscribeReply_Error(UnsubscribeReply_Error&& from) noexcept
    : UnsubscribeReply_Error() {
    *this = ::std::move(from);
  }

  inline UnsubscribeReply_Error& operator=(UnsubscribeReply_Error&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const UnsubscribeReply_Error& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const UnsubscribeReply_Error* internal_default_instance() {
    return reinterpret_cast<const UnsubscribeReply_Error*>(
               &_UnsubscribeReply_Error_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    4;

  void Swap(UnsubscribeReply_Error* other);
  friend void swap(UnsubscribeReply_Error& a, UnsubscribeReply_Error& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline UnsubscribeReply_Error* New() const PROTOBUF_FINAL { return New(NULL); }

  UnsubscribeReply_Error* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const UnsubscribeReply_Error& from);
  void MergeFrom(const UnsubscribeReply_Error& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(UnsubscribeReply_Error* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string message = 2;
  void clear_message();
  static const int kMessageFieldNumber = 2;
  const ::std::string& message() const;
  void set_message(const ::std::string& value);
  #if LANG_CXX11
  void set_message(::std::string&& value);
  #endif
  void set_message(const char* value);
  void set_message(const char* value, size_t size);
  ::std::string* mutable_message();
  ::std::string* release_message();
  void set_allocated_message(::std::string* message);

  // int64 code = 1;
  void clear_code();
  static const int kCodeFieldNumber = 1;
  ::google::protobuf::int64 code() const;
  void set_code(::google::protobuf::int64 value);

  // @@protoc_insertion_point(class_scope:mascot.UnsubscribeReply.Error)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr message_;
  ::google::protobuf::int64 code_;
  mutable int _cached_size_;
  friend struct ::protobuf_subscriptions_2eproto::TableStruct;
  friend void ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReply_ErrorImpl();
};
// -------------------------------------------------------------------

class UnsubscribeReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.UnsubscribeReply) */ {
 public:
  UnsubscribeReply();
  virtual ~UnsubscribeReply();

  UnsubscribeReply(const UnsubscribeReply& from);

  inline UnsubscribeReply& operator=(const UnsubscribeReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  UnsubscribeReply(UnsubscribeReply&& from) noexcept
    : UnsubscribeReply() {
    *this = ::std::move(from);
  }

  inline UnsubscribeReply& operator=(UnsubscribeReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const UnsubscribeReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const UnsubscribeReply* internal_default_instance() {
    return reinterpret_cast<const UnsubscribeReply*>(
               &_UnsubscribeReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    5;

  void Swap(UnsubscribeReply* other);
  friend void swap(UnsubscribeReply& a, UnsubscribeReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline UnsubscribeReply* New() const PROTOBUF_FINAL { return New(NULL); }

  UnsubscribeReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const UnsubscribeReply& from);
  void MergeFrom(const UnsubscribeReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(UnsubscribeReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  typedef UnsubscribeReply_Error Error;

  // accessors -------------------------------------------------------

  // .mascot.UnsubscribeReply.Error error = 2;
  bool has_error() const;
  void clear_error();
  static const int kErrorFieldNumber = 2;
  const ::mascot::UnsubscribeReply_Error& error() const;
  ::mascot::UnsubscribeReply_Error* release_error();
  ::mascot::UnsubscribeReply_Error* mutable_error();
  void set_allocated_error(::mascot::UnsubscribeReply_Error* error);

  // bool success = 1;
  void clear_success();
  static const int kSuccessFieldNumber = 1;
  bool success() const;
  void set_success(bool value);

  // @@protoc_insertion_point(class_scope:mascot.UnsubscribeReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::mascot::UnsubscribeReply_Error* error_;
  bool success_;
  mutable int _cached_size_;
  friend struct ::protobuf_subscriptions_2eproto::TableStruct;
  friend void ::protobuf_subscriptions_2eproto::InitDefaultsUnsubscribeReplyImpl();
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// SubscribeMessage

// string deviceName = 1;
inline void SubscribeMessage::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& SubscribeMessage::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.SubscribeMessage.deviceName)
  return devicename_.GetNoArena();
}
inline void SubscribeMessage::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.SubscribeMessage.deviceName)
}
#if LANG_CXX11
inline void SubscribeMessage::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.SubscribeMessage.deviceName)
}
#endif
inline void SubscribeMessage::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.SubscribeMessage.deviceName)
}
inline void SubscribeMessage::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.SubscribeMessage.deviceName)
}
inline ::std::string* SubscribeMessage::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.SubscribeMessage.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* SubscribeMessage::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.SubscribeMessage.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void SubscribeMessage::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.SubscribeMessage.deviceName)
}

// string attributeName = 2;
inline void SubscribeMessage::clear_attributename() {
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& SubscribeMessage::attributename() const {
  // @@protoc_insertion_point(field_get:mascot.SubscribeMessage.attributeName)
  return attributename_.GetNoArena();
}
inline void SubscribeMessage::set_attributename(const ::std::string& value) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.SubscribeMessage.attributeName)
}
#if LANG_CXX11
inline void SubscribeMessage::set_attributename(::std::string&& value) {
  
  attributename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.SubscribeMessage.attributeName)
}
#endif
inline void SubscribeMessage::set_attributename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.SubscribeMessage.attributeName)
}
inline void SubscribeMessage::set_attributename(const char* value, size_t size) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.SubscribeMessage.attributeName)
}
inline ::std::string* SubscribeMessage::mutable_attributename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.SubscribeMessage.attributeName)
  return attributename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* SubscribeMessage::release_attributename() {
  // @@protoc_insertion_point(field_release:mascot.SubscribeMessage.attributeName)
  
  return attributename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void SubscribeMessage::set_allocated_attributename(::std::string* attributename) {
  if (attributename != NULL) {
    
  } else {
    
  }
  attributename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), attributename);
  // @@protoc_insertion_point(field_set_allocated:mascot.SubscribeMessage.attributeName)
}

// .mascot.SubscriptionFlavor flavor = 3;
inline void SubscribeMessage::clear_flavor() {
  flavor_ = 0;
}
inline ::mascot::SubscriptionFlavor SubscribeMessage::flavor() const {
  // @@protoc_insertion_point(field_get:mascot.SubscribeMessage.flavor)
  return static_cast< ::mascot::SubscriptionFlavor >(flavor_);
}
inline void SubscribeMessage::set_flavor(::mascot::SubscriptionFlavor value) {
  
  flavor_ = value;
  // @@protoc_insertion_point(field_set:mascot.SubscribeMessage.flavor)
}

// -------------------------------------------------------------------

// SubscribeReply_Error

// int64 code = 1;
inline void SubscribeReply_Error::clear_code() {
  code_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 SubscribeReply_Error::code() const {
  // @@protoc_insertion_point(field_get:mascot.SubscribeReply.Error.code)
  return code_;
}
inline void SubscribeReply_Error::set_code(::google::protobuf::int64 value) {
  
  code_ = value;
  // @@protoc_insertion_point(field_set:mascot.SubscribeReply.Error.code)
}

// string message = 2;
inline void SubscribeReply_Error::clear_message() {
  message_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& SubscribeReply_Error::message() const {
  // @@protoc_insertion_point(field_get:mascot.SubscribeReply.Error.message)
  return message_.GetNoArena();
}
inline void SubscribeReply_Error::set_message(const ::std::string& value) {
  
  message_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.SubscribeReply.Error.message)
}
#if LANG_CXX11
inline void SubscribeReply_Error::set_message(::std::string&& value) {
  
  message_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.SubscribeReply.Error.message)
}
#endif
inline void SubscribeReply_Error::set_message(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  message_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.SubscribeReply.Error.message)
}
inline void SubscribeReply_Error::set_message(const char* value, size_t size) {
  
  message_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.SubscribeReply.Error.message)
}
inline ::std::string* SubscribeReply_Error::mutable_message() {
  
  // @@protoc_insertion_point(field_mutable:mascot.SubscribeReply.Error.message)
  return message_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* SubscribeReply_Error::release_message() {
  // @@protoc_insertion_point(field_release:mascot.SubscribeReply.Error.message)
  
  return message_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void SubscribeReply_Error::set_allocated_message(::std::string* message) {
  if (message != NULL) {
    
  } else {
    
  }
  message_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), message);
  // @@protoc_insertion_point(field_set_allocated:mascot.SubscribeReply.Error.message)
}

// -------------------------------------------------------------------

// SubscribeReply

// bool success = 1;
inline void SubscribeReply::clear_success() {
  success_ = false;
}
inline bool SubscribeReply::success() const {
  // @@protoc_insertion_point(field_get:mascot.SubscribeReply.success)
  return success_;
}
inline void SubscribeReply::set_success(bool value) {
  
  success_ = value;
  // @@protoc_insertion_point(field_set:mascot.SubscribeReply.success)
}

// .mascot.SubscribeReply.Error error = 2;
inline bool SubscribeReply::has_error() const {
  return this != internal_default_instance() && error_ != NULL;
}
inline void SubscribeReply::clear_error() {
  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
}
inline const ::mascot::SubscribeReply_Error& SubscribeReply::error() const {
  const ::mascot::SubscribeReply_Error* p = error_;
  // @@protoc_insertion_point(field_get:mascot.SubscribeReply.error)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::SubscribeReply_Error*>(
      &::mascot::_SubscribeReply_Error_default_instance_);
}
inline ::mascot::SubscribeReply_Error* SubscribeReply::release_error() {
  // @@protoc_insertion_point(field_release:mascot.SubscribeReply.error)
  
  ::mascot::SubscribeReply_Error* temp = error_;
  error_ = NULL;
  return temp;
}
inline ::mascot::SubscribeReply_Error* SubscribeReply::mutable_error() {
  
  if (error_ == NULL) {
    error_ = new ::mascot::SubscribeReply_Error;
  }
  // @@protoc_insertion_point(field_mutable:mascot.SubscribeReply.error)
  return error_;
}
inline void SubscribeReply::set_allocated_error(::mascot::SubscribeReply_Error* error) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete error_;
  }
  if (error) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      error = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, error, submessage_arena);
    }
    
  } else {
    
  }
  error_ = error;
  // @@protoc_insertion_point(field_set_allocated:mascot.SubscribeReply.error)
}

// -------------------------------------------------------------------

// UnsubscribeMessage

// string deviceName = 1;
inline void UnsubscribeMessage::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& UnsubscribeMessage::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.UnsubscribeMessage.deviceName)
  return devicename_.GetNoArena();
}
inline void UnsubscribeMessage::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.UnsubscribeMessage.deviceName)
}
#if LANG_CXX11
inline void UnsubscribeMessage::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.UnsubscribeMessage.deviceName)
}
#endif
inline void UnsubscribeMessage::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.UnsubscribeMessage.deviceName)
}
inline void UnsubscribeMessage::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.UnsubscribeMessage.deviceName)
}
inline ::std::string* UnsubscribeMessage::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.UnsubscribeMessage.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* UnsubscribeMessage::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.UnsubscribeMessage.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void UnsubscribeMessage::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.UnsubscribeMessage.deviceName)
}

// string attributeName = 2;
inline void UnsubscribeMessage::clear_attributename() {
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& UnsubscribeMessage::attributename() const {
  // @@protoc_insertion_point(field_get:mascot.UnsubscribeMessage.attributeName)
  return attributename_.GetNoArena();
}
inline void UnsubscribeMessage::set_attributename(const ::std::string& value) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.UnsubscribeMessage.attributeName)
}
#if LANG_CXX11
inline void UnsubscribeMessage::set_attributename(::std::string&& value) {
  
  attributename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.UnsubscribeMessage.attributeName)
}
#endif
inline void UnsubscribeMessage::set_attributename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.UnsubscribeMessage.attributeName)
}
inline void UnsubscribeMessage::set_attributename(const char* value, size_t size) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.UnsubscribeMessage.attributeName)
}
inline ::std::string* UnsubscribeMessage::mutable_attributename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.UnsubscribeMessage.attributeName)
  return attributename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* UnsubscribeMessage::release_attributename() {
  // @@protoc_insertion_point(field_release:mascot.UnsubscribeMessage.attributeName)
  
  return attributename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void UnsubscribeMessage::set_allocated_attributename(::std::string* attributename) {
  if (attributename != NULL) {
    
  } else {
    
  }
  attributename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), attributename);
  // @@protoc_insertion_point(field_set_allocated:mascot.UnsubscribeMessage.attributeName)
}

// -------------------------------------------------------------------

// UnsubscribeReply_Error

// int64 code = 1;
inline void UnsubscribeReply_Error::clear_code() {
  code_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 UnsubscribeReply_Error::code() const {
  // @@protoc_insertion_point(field_get:mascot.UnsubscribeReply.Error.code)
  return code_;
}
inline void UnsubscribeReply_Error::set_code(::google::protobuf::int64 value) {
  
  code_ = value;
  // @@protoc_insertion_point(field_set:mascot.UnsubscribeReply.Error.code)
}

// string message = 2;
inline void UnsubscribeReply_Error::clear_message() {
  message_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& UnsubscribeReply_Error::message() const {
  // @@protoc_insertion_point(field_get:mascot.UnsubscribeReply.Error.message)
  return message_.GetNoArena();
}
inline void UnsubscribeReply_Error::set_message(const ::std::string& value) {
  
  message_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.UnsubscribeReply.Error.message)
}
#if LANG_CXX11
inline void UnsubscribeReply_Error::set_message(::std::string&& value) {
  
  message_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.UnsubscribeReply.Error.message)
}
#endif
inline void UnsubscribeReply_Error::set_message(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  message_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.UnsubscribeReply.Error.message)
}
inline void UnsubscribeReply_Error::set_message(const char* value, size_t size) {
  
  message_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.UnsubscribeReply.Error.message)
}
inline ::std::string* UnsubscribeReply_Error::mutable_message() {
  
  // @@protoc_insertion_point(field_mutable:mascot.UnsubscribeReply.Error.message)
  return message_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* UnsubscribeReply_Error::release_message() {
  // @@protoc_insertion_point(field_release:mascot.UnsubscribeReply.Error.message)
  
  return message_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void UnsubscribeReply_Error::set_allocated_message(::std::string* message) {
  if (message != NULL) {
    
  } else {
    
  }
  message_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), message);
  // @@protoc_insertion_point(field_set_allocated:mascot.UnsubscribeReply.Error.message)
}

// -------------------------------------------------------------------

// UnsubscribeReply

// bool success = 1;
inline void UnsubscribeReply::clear_success() {
  success_ = false;
}
inline bool UnsubscribeReply::success() const {
  // @@protoc_insertion_point(field_get:mascot.UnsubscribeReply.success)
  return success_;
}
inline void UnsubscribeReply::set_success(bool value) {
  
  success_ = value;
  // @@protoc_insertion_point(field_set:mascot.UnsubscribeReply.success)
}

// .mascot.UnsubscribeReply.Error error = 2;
inline bool UnsubscribeReply::has_error() const {
  return this != internal_default_instance() && error_ != NULL;
}
inline void UnsubscribeReply::clear_error() {
  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
}
inline const ::mascot::UnsubscribeReply_Error& UnsubscribeReply::error() const {
  const ::mascot::UnsubscribeReply_Error* p = error_;
  // @@protoc_insertion_point(field_get:mascot.UnsubscribeReply.error)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::UnsubscribeReply_Error*>(
      &::mascot::_UnsubscribeReply_Error_default_instance_);
}
inline ::mascot::UnsubscribeReply_Error* UnsubscribeReply::release_error() {
  // @@protoc_insertion_point(field_release:mascot.UnsubscribeReply.error)
  
  ::mascot::UnsubscribeReply_Error* temp = error_;
  error_ = NULL;
  return temp;
}
inline ::mascot::UnsubscribeReply_Error* UnsubscribeReply::mutable_error() {
  
  if (error_ == NULL) {
    error_ = new ::mascot::UnsubscribeReply_Error;
  }
  // @@protoc_insertion_point(field_mutable:mascot.UnsubscribeReply.error)
  return error_;
}
inline void UnsubscribeReply::set_allocated_error(::mascot::UnsubscribeReply_Error* error) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete error_;
  }
  if (error) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      error = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, error, submessage_arena);
    }
    
  } else {
    
  }
  error_ = error;
  // @@protoc_insertion_point(field_set_allocated:mascot.UnsubscribeReply.error)
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_subscriptions_2eproto__INCLUDED
